Public Class Form1
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Remove any existing items.
        lvwBooks.Items.Clear()

        ' Add data rows.
        ListViewMakeRow(lvwBooks, "Ready-to-Run Visual Basic Algorithms", "http://www.vb-helper.com/vba.htm", "0-471-24268-3", "http://www.vb-helper.com/vba.jpg", "395", "1998", "1/5/1998")
        ListViewMakeRow(lvwBooks, "Visual Basic Graphics Programming", "http://www.vb-helper.com/vbgp.htm", "0-472-35599-2", "http://www.vb-helper.com/vbgp.jpg", "712", "2000", "2/2/2000")
        ListViewMakeRow(lvwBooks, "Advanced Visual Basic Techniques", "http://www.vb-helper.com/avbt.htm", "0-471-18881-6", "http://www.vb-helper.com/avbt.jpg", "440", "1997", "3/3/1997")
        ListViewMakeRow(lvwBooks, "Custom Controls Library", "http://www.vb-helper.com/ccl.htm", "0-471-24267-5", "http://www.vb-helper.com/ccl.jpg", "684", "1998", "10/10/1998")
        ListViewMakeRow(lvwBooks, "Ready-to-Run Delphi Algorithms", "http://www.vb-helper.com/da.htm", "0-471-25400-2", "http://www.vb-helper.com/da.jpg", "398", "1998", "01/20/1998")
        ListViewMakeRow(lvwBooks, "Bug Proofing Visual Basic", "http://www.vb-helper.com/err.htm", "0-471-32351-9", "http://www.vb-helper.com/err.jpg", "397", "1999", "5/5/1999")
        ListViewMakeRow(lvwBooks, "Ready-to-Run Visual Basic Code Library", "http://www.vb-helper.com/vbcl.htm", "0-471-33345-X", "http://www.vb-helper.com/vbcl.jpg", "424", "1999", "8/8/1999")

        ListViewMakeRow(lvwBooks, "Bogus Book", "http://www.noplace.com/bogus.htm", "0-123-45678-9", "http://www.noplace.com/bogus.jpg", "100", "6", "1/09/1998")
        ListViewMakeRow(lvwBooks, "Fakey", "http://www.skatepark.com/fakey.htm", "9-876-54321-0", "http://www.skatepark.com/fakey.jpg", "9", "700", "1/08/1998")

        ' Make the ListView column headers.
        ListViewMakeColumnHeaders(lvwBooks, _
            "Title", HorizontalAlignment.Left, _
            "URL", HorizontalAlignment.Left, _
            "ISBN", HorizontalAlignment.Left, _
            "Picture", HorizontalAlignment.Left, _
            "Pages", HorizontalAlignment.Right, _
            "Year", HorizontalAlignment.Right, _
            "Pub Date", HorizontalAlignment.Right)

        ' Size the columns.
        For i As Integer = 0 To lvwBooks.Columns.Count - 1
            lvwBooks.Columns(i).Width = -2
        Next i

        ' Make the form big enough to show the ListView.
        Dim item_rect As Rectangle = _
            lvwBooks.GetItemRect(lvwBooks.Columns.Count - 1)
        Me.SetClientSizeCore( _
            item_rect.Left + item_rect.Width + 50, _
            item_rect.Top + item_rect.Height + 75)

    End Sub

    ' Make a ListView row.
    Private Sub ListViewMakeRow(ByVal lvw As ListView, ByVal item_title As String, ByVal ParamArray subitem_titles() As String)
        ' Make the item.
        Dim new_item As ListViewItem = lvw.Items.Add(item_title)

        ' Make the sub-items.
        For i As Integer = subitem_titles.GetLowerBound(0) To subitem_titles.GetUpperBound(0)
            new_item.SubItems.Add(subitem_titles(i))
        Next i
    End Sub

    ' Make the ListView's column headers.
    ' The ParamArray entries should alternate between
    ' strings and HorizontalAlignment values.
    Private Sub ListViewMakeColumnHeaders(ByVal lvw As ListView, ByVal ParamArray header_info() As Object)
        ' Remove any existing headers.
        lvw.Columns.Clear()

        ' Make the column headers.
        For i As Integer = header_info.GetLowerBound(0) To header_info.GetUpperBound(0) Step 2
            lvw.Columns.Add( _
                DirectCast(header_info(i), String), _
                -1, _
                DirectCast(header_info(i + 1), HorizontalAlignment))
        Next i
    End Sub

    ' Display the row and column under the mouse.
    Private Sub lvwBooks_MouseMove(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles lvwBooks.MouseMove
        txtRow.Clear()
        txtColumn.Clear()

#If False Then
        ' Method 1: Use FindListViewRowColumn.
        Dim row, column As Integer
        If FindListViewRowColumn(lvwBooks, e.X, e.Y, row, column) Then
            txtRow.Text = row.ToString()
            txtColumn.Text = column.ToString()
        End If
#ElseIf False Then
        ' Method 2: Use HitTest.
        Dim hti As ListViewHitTestInfo = lvwBooks.HitTest(e.Location)
        If (hti.Item Is Nothing) Then Return
        Dim item As ListViewItem = hti.Item
        txtRow.Text = item.Index.ToString()

        ' See which sub-item this is.
        Dim subitem As ListViewItem.ListViewSubItem = hti.SubItem
        For i As Integer = 0 To item.SubItems.Count - 1
            If (item.SubItems(i) Is subitem) Then
                txtColumn.Text = i.ToString()
            End If
        Next i
#Else
        ' Method 3: Use HitTest and IndexOf.
        Dim hti As ListViewHitTestInfo = lvwBooks.HitTest(e.Location)
        If hti.Item Is Nothing Then Return
        Dim item As ListViewItem = hti.Item
        txtRow.Text = item.Index.ToString()

        ' See which sub-item this is.
        txtColumn.Text = item.SubItems.IndexOf(hti.SubItem).ToString()
#End If
    End Sub
End Class
